blob: 48c09600b980c78b82f1521dbd7885a8ba7ae87f [file] [log] [blame]
Philipp Schrader773577f2021-12-17 23:45:39 -08001#!/bin/bash
2
3# Perform runfile initialization here so that child processes have a proper
4# RUNFILES_DIR variable set.
5
6# --- begin runfiles.bash initialization v2 ---
7# Copy-pasted from the Bazel Bash runfiles library v2.
8set -uo pipefail; f=bazel_tools/tools/bash/runfiles/runfiles.bash
9source "${RUNFILES_DIR:-/dev/null}/$f" 2>/dev/null || \
10 source "$(grep -sm1 "^$f " "${RUNFILES_MANIFEST_FILE:-/dev/null}" | cut -f2- -d' ')" 2>/dev/null || \
11 source "$0.runfiles/$f" 2>/dev/null || \
12 source "$(grep -sm1 "^$f " "$0.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
13 source "$(grep -sm1 "^$f " "$0.exe.runfiles_manifest" | cut -f2- -d' ')" 2>/dev/null || \
14 { echo>&2 "ERROR: cannot find $f"; exit 1; }; f=; set -e
15# --- end runfiles.bash initialization v2 ---
16
Philipp Schrader37fdbb62021-12-18 00:30:37 -080017set -o nounset
18
19# Redirect the Go cache on buildkite. Otherwise we run into errors like:
20# "failed to initialize build cache at /var/lib/buildkite-agent/.cache/go-build"
21# due to permission errors.
22if ((RUNNING_IN_CI == 1)); then
23 export GOCACHE=/tmp/lint_go_cache
24fi
25
Philipp Schrader773577f2021-12-17 23:45:39 -080026gofmt() {
27 ./tools/lint/gofmt
28}
29
Philipp Schrader37fdbb62021-12-18 00:30:37 -080030gomod() {
31 local -r go="$(readlink -f external/go_sdk/bin/go)"
32 cd "${BUILD_WORKSPACE_DIRECTORY}"
33 "${go}" mod tidy -e
34}
35
36update_repos() {
37 ./gazelle-runner.bash update-repos \
38 -from_file=go.mod \
39 -to_macro=go_deps.bzl%go_dependencies \
40 -prune
41}
42
43gazelle() {
44 ./gazelle-runner.bash
45}
46
47tweak_gazelle_go_deps() {
48 local -r tweaker="$(readlink -f tools/go/tweak_gazelle_go_deps)"
49 cd "${BUILD_WORKSPACE_DIRECTORY}"
50 "${tweaker}" ./go_deps.bzl
51}
52
Philipp Schrader773577f2021-12-17 23:45:39 -080053git_status_is_clean() {
54 cd "${BUILD_WORKSPACE_DIRECTORY}"
55 if ! git diff --quiet; then
56 echo "One or more linters appear to have made changes to your code!" >&2
57 return 1
58 fi
59}
60
61# All the linters that we are going to run.
62readonly -a LINTERS=(
63 gofmt
Philipp Schrader37fdbb62021-12-18 00:30:37 -080064 gomod
65 update_repos
66 gazelle
67 tweak_gazelle_go_deps
Philipp Schrader773577f2021-12-17 23:45:39 -080068 git_status_is_clean # This must the last linter.
69)
70
71failure=0
72for linter in "${LINTERS[@]}"; do
73 if ! (eval "${linter}"); then
74 failure=1
75 fi
76done
77
78if ((failure != 0)); then
79 echo "One or more linters failed." >&2
80 cd "${BUILD_WORKSPACE_DIRECTORY}"
81 git --no-pager diff || :
82 exit "${failure}"
83fi
84
85exit 0